<template>
  <transition-group
    name="popups"
    tag="section"
  >
    <component
      :is="popup.component"
      v-for="popup in shownPopups"
      :key="popup.id"
    />
  </transition-group>
</template>

<script lang="ts" setup>
import { usePopupsStore } from '~/stores/popups';
import { ERROR_POPUP, USER_SETTINGS_POPUP } from '~/entities/popups';

const popups = [
  {
    id: ERROR_POPUP,
    component: defineAsyncComponent(async () => {
      const { PopupSettings } = await import('~/widgets/user');
      return PopupSettings;
    }),
  },
  {
    id: USER_SETTINGS_POPUP,
    state: false,
    component: defineAsyncComponent(async () => {
      const { PopupSettings } = await import('~/widgets/user');
      return PopupSettings;
    }),
  },
];

const store = usePopupsStore();
const shownPopups = computed(() => {
  return popups.filter((popup) => store.popups.find((p) => p.id === popup.id));
});
</script>
